var backWidth = 220;
var backHeight = 290;
var frontWidth = 269;
var frontHeight = 470;
var backshown = false;
var scrollbar;
var scrollArea;
var timer;


function setup() {
  if (window.widget) {
    widgetSetup();
    widget.onshow = onshow;
    widget.onremove = onremove;
    if (widget.context != null) {
      var link = document.getElementById("Widgetop");
      if (link != null) {
        link.style.display = "none";
      }
    }
    var value = widget.preferenceForKey(widget.identifier + "-type");  
    if (value) {
      document.getElementById("ListType").value = value;
      reload();
    }      
  }  
}

function onshow() {
  window.resizeTo(frontWidth, frontHeight);
  timer = setInterval(reload, 60 * 60000);
}

function onhide() {
  if (timer) {
    clearInterval(timer);
  }
}

function onremove() {
  widget.setPreferenceForKey(null, widget.identifier + "-type");  
}

  function initialize() {
    document.getElementById("Loading").style.visibility = "visible";
    document.getElementById("List").innerHTML = "";
    var type = document.getElementById("ListType").value;
    if (window.widget) {
      widget.setPreferenceForKey(type, widget.identifier + "-type");
    }
    var url = "";  
    if (type.indexOf("http") < 0) {
      url = "http://www.apple.com/webapps/" + type;
      url += "/recent.rss";
    }
    else {
      url = type;
    }  
    var feed = new google.feeds.Feed(url);
    feed.setNumEntries(32);
    feed.load(function(result) {
      if (!result.error) {
        var container = document.getElementById("List");
        for (var i = 0; i < result.feed.entries.length; i++) {
          var entry = result.feed.entries[i];
          var li = document.createElement("li");
          li.link = entry.link;
          li.onclick = function() {
            widget.openURL(this.link);
          }
          container.appendChild(li);
          var icon = document.createElement("img");
          icon.className = "listIcon";
          var content = entry.content;
          var index = content.indexOf("<img");
          if (index >= 0) {
            index = content.indexOf("src=\"", index);
            var index2 = content.indexOf("\"", index + 5);
            if (index2 > 0) {
              icon.src = content.substring(index + 5, index2);
            }
          }
          li.appendChild(icon);
          var title = document.createElement("div");
          title.className = "listTitle";
          title.innerHTML = entry.title;
          li.appendChild(title);
          var body = document.createElement("div");
          body.className = "listBody";
          title.body = body;
          li.appendChild(body);
          var description = document.createElement("div");
          description.className = "listDescription";
          description.innerHTML = entry.contentSnippet;
          body.appendChild(description);          
          var link = document.createElement("a");
          link.className = "listLink";
          link.innerHTML = "Open";
          link.href = entry.link;
          link.target = "_blank";
          body.appendChild(link);          
          var date = document.createElement("div");
          date.className = "listDate";
          date.innerHTML = entry.publishedDate;
          li.appendChild(date);
        }
        document.getElementById("Loading").style.visibility = "hidden";
        scrollArea.refresh();
      }
    });
  }

  function reload() {
    initialize();
  }

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "white", "white", showBack);
    scrollbar = new AppleVerticalScrollbar(document.getElementById("VScrollBar"));
  	scrollArea = new AppleScrollArea(document.getElementById("Content"), scrollbar);
  	scrollArea.scrollsHorizontally = false;
  	scrollArea.singlepressScrollPixels = 15;
  	
  	scrollArea.focus(); // for key control when first loading in Safari
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    backShown = true;
    front.style.display="none";
    window.resizeTo(backWidth, backHeight);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    backShown = false;
    back.style.display="none";
    window.resizeTo(frontWidth, frontHeight);  
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
    reload();    
}                                                
  